{ This demoprogram shows how to use the statistics functions implemented
  in ChroMathsome.

  The reader may do with this code whatever he/she desires.
  Author: John Merrit (john.merrit@net4all.be)
  Release date: 3 January '96

  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
  WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

  Brought to you by the letter "M".             }

unit Stat1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    MainMenu1: TMainMenu;
    Exit1: TMenuItem;
    Basic1: TMenuItem;
    Regression1: TMenuItem;
    PolyRegression1: TMenuItem;
    TestStat1: TMenuItem;
    Pairedt1: TMenuItem;
    chi1: TMenuItem;
    Sum1: TMenuItem;
    Mean1: TMenuItem;
    StdDeviation1: TMenuItem;
    N1: TMenuItem;
    Firstsecondthirdandfourthmoment1: TMenuItem;
    Coeffofskewness1: TMenuItem;
    Coeffofkurtosis1: TMenuItem;
    Linear1: TMenuItem;
    Logarithmic1: TMenuItem;
    Exponential1: TMenuItem;
    Power1: TMenuItem;
    N2: TMenuItem;
    Bestfit1: TMenuItem;
    N3: TMenuItem;
    Multlinregression1: TMenuItem;
    Twoindepvar1: TMenuItem;
    Threeindepvariables1: TMenuItem;
    Parabolic1: TMenuItem;
    Cubic1: TMenuItem;
    procedure Sum1Click(Sender: TObject);
    procedure Mean1Click(Sender: TObject);
    procedure Moments(Sender: TObject);
    procedure Linear1Click(Sender: TObject);
    procedure Logarithmic1Click(Sender: TObject);
    procedure Exponential1Click(Sender: TObject);
    procedure Power1Click(Sender: TObject);
    procedure Bestfit1Click(Sender: TObject);
    procedure Parabolic1Click(Sender: TObject);
    procedure Cubic1Click(Sender: TObject);
    procedure Twoindepvar1Click(Sender: TObject);
    procedure Threeindepvariables1Click(Sender: TObject);
    procedure Pairedt1Click(Sender: TObject);
    procedure chi1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses Statistc;

procedure TForm1.Sum1Click(Sender: TObject);
var x: extended;
    a: array[1..5] of extended;
begin
    a[1]:= 5;
    a[2]:= 2;
    a[3]:= 4;
    a[4]:= 3;
    a[5]:= 7;
    x:= Sum(a);
    Memo1.Lines.add('Sum: ' + floattostr(x));
end;

{ Calculate the mean of the data in Data.  
  Data is of type open array.
  This means that you just pass the array through to the function/procedure
  without first declaring the array as a separate variable.
  See Delphi help file for more information about this datatype.
  You can also pass the data in a pre-defined array (see sum, above).          }
procedure TForm1.Mean1Click(Sender: TObject);
var DMean, Deviation: extended;
begin
    if Sender = Mean1 then
    begin
    DMean:= Mean([26,30,44,50,62,68,74]); { Here's the open array used. }
    Memo1.lines.add('Mean: ' + FloatTostr(DMean))
    end
    else if Sender = StdDeviation1 then
    begin
    Deviation:= StdDev([26,30,44,50,62,68,74]);
    Memo1.lines.add('Standard deviation: ' + FloatTostr(Deviation));
    end;
end;

{ Calculate the 1st, 2nd, 3rth and 4th moments and the cofficients of skewness and
  kurtosis for the data in Data.  }
procedure TForm1.Moments(Sender: TObject);
var M1, M2, M3, M4, Skew, Kurtosis: extended;
begin
    MomentSkewKurtosis([2.1,3.5,4.2,6.5,4.1,3.6,5.3,3.7,4.9], M1, M2, M3, M4, Skew, Kurtosis);
    if Sender = Firstsecondthirdandfourthmoment1 then
    Memo1.lines.add('Moments: ' + FloatTostr(M1) + ' ' + FloatTostr(M2) + ' ' + FloatTostr(M3) +
    ' ' + FloatTostr(M4))
    else if Sender = CoeffofSkewness1 then
    Memo1.lines.add('Cofficient of skewness: ' + FloatTostr(skew))
    else if Sender = CoeffofKurtosis1 then
    Memo1.lines.add('Cofficient of kurtosis: ' + FloatTostr(kurtosis));
end;

{ Calculate the coeffic. of a straight line (y = a + b*x) that fits the data supplied in X and Y
  The statistical data must be supplied within two arrays (X and Y).
  Your data is of the form (Xi, Yi).
  Don't forget that the dimensions of X and Y must be the same!!!  }
procedure TForm1.Linear1Click(Sender: TObject);
var a, b, r: extended;
begin
    CurveFitting(a,b,r,[40.5,38.6,37.9,36.2,35.1,34.6],[104.5,102,100,97.5,95.5,94], Linear);
    Memo1.Lines.add('a:= ' + FloatToStr(a));
    Memo1.Lines.add('b:= ' + FloatToStr(b));
    Memo1.Lines.add('r:= ' + FloatToStr(r));
end;

{ Same but now for a logarithmic curve (y = a + b*ln(x)).    }
procedure TForm1.Logarithmic1Click(Sender: TObject);
var a, b, r: extended;
begin
    CurveFitting(a,b,r,[3,4,6,10,12],[1.5,9.3,23.4,45.8,60.1], Logarithmic);
    Memo1.Lines.add('a:= ' + FloatToStr(a));
    Memo1.Lines.add('b:= ' + FloatToStr(b));
    Memo1.Lines.add('r:= ' + FloatToStr(r));
end;

{ Same but now for an exponential curve (y = a*e^(b*x)).    }
procedure TForm1.Exponential1Click(Sender: TObject);
var a, b, r: extended;
begin
    CurveFitting(a,b,r,[0.72,1.31,1.95,2.58,3.14],[2.16,1.61,1.16,0.85,0.5], Exponential);
    Memo1.Lines.add('a:= ' + FloatToStr(a));
    Memo1.Lines.add('b:= ' + FloatToStr(b));
    Memo1.Lines.add('r:= ' + FloatToStr(r));
end;

{ Same but now for a power curve (y = a*x^b).    }
procedure TForm1.Power1Click(Sender: TObject);
var a, b, r: extended;
begin
    CurveFitting(a,b,r,[10,12,15,17,20,22,25,27,30,32,35],
                       [0.95,1.05,1.25,1.41,1.73,2,2.53,2.98,3.85,4.59,6.02], Power);
    Memo1.Lines.add('a:= ' + FloatToStr(a));
    Memo1.Lines.add('b:= ' + FloatToStr(b));
    Memo1.Lines.add('r:= ' + FloatToStr(r));
end;

{ Let's see wich of the above curves fits the data best.
  The example data points are the same as the for the power curve above.  }
procedure TForm1.Bestfit1Click(Sender: TObject);
var a, b, r: extended;
    CurveType: CurveFittingType;
begin
     CurveType:= BestFit(a,b,r,[10,12,15,17,20,22,25,27,30,32,35],
                       [0.95,1.05,1.25,1.41,1.73,2,2.53,2.98,3.85,4.59,6.02]);
    case CurveType of
    Linear:begin
           Memo1.Lines.add('Best fit is a straight line y = a + b*x with:');
           Memo1.Lines.add('a:= ' + FloatToStr(a));
           Memo1.Lines.add('b:= ' + FloatToStr(b));
           Memo1.Lines.add('r:= ' + FloatToStr(r));
           end;
    Exponential:begin
                Memo1.Lines.add('Best fit is an exponential curve y = a*exp(b*x) with:');
                Memo1.Lines.add('a:= ' + FloatToStr(a));
                Memo1.Lines.add('b:= ' + FloatToStr(b));
                Memo1.Lines.add('r:= ' + FloatToStr(r));
                end;
    Logarithmic:begin
                Memo1.Lines.add('Best fit is a logarithmic curve y = a + b*ln(x) with:');
                Memo1.Lines.add('a:= ' + FloatToStr(a));
                Memo1.Lines.add('b:= ' + FloatToStr(b));
                Memo1.Lines.add('r:= ' + FloatToStr(r));
                end;
    Power:begin
          Memo1.Lines.add('Best fit is a power curve y = a*x^b with:');
          Memo1.Lines.add('a:= ' + FloatToStr(a));
          Memo1.Lines.add('b:= ' + FloatToStr(b));
          Memo1.Lines.add('r:= ' + FloatToStr(r));
          end;
    end;
end;

{ Same but now for a parabolic curve (y = a + b*x + c*x).    }
procedure TForm1.Parabolic1Click(Sender: TObject);
var a, b, c, d, r: extended;
begin
    PolyRegression(a, b, c, d, r,[1,2,3,4,5,6,7],[5,12,34,50,75,84,128], Parabolic);
    Memo1.Lines.add('a:= ' + FloatToStr(a));
    Memo1.Lines.add('b:= ' + FloatToStr(b));
    Memo1.Lines.add('c:= ' + FloatToStr(c));
    Memo1.Lines.add('r:= ' + FloatToStr(r));
end;

{ Same but now for a cubic curve (y = a + b*x + c*x + d*x).    }
procedure TForm1.Cubic1Click(Sender: TObject);
var a, b, c, d, r: extended;
begin
    PolyRegression(a, b, c, d, r,[0.8,1,1.2,1.4,1.6],[24,20,10,13,12], Cubic);
    Memo1.Lines.add('a:= ' + FloatToStr(a));
    Memo1.Lines.add('b:= ' + FloatToStr(b));
    Memo1.Lines.add('c:= ' + FloatToStr(c));
    Memo1.Lines.add('d:= ' + FloatToStr(d));
    Memo1.Lines.add('r:= ' + FloatToStr(r));
end;

{ Calculate the coeffic. a, b, c so that the data supplied in statistical vectors X, Y, T fits
  t = a + b*x + c*y.
  This is a linear equation in two independent variables.
  The technique is called Multiple Linear Regression.                                    }
procedure TForm1.Twoindepvar1Click(Sender: TObject);
var a, b, c, r: extended;
begin
    MultiLinearRegression1(a,b,c,r,[1.5,0.45,1.8,2.8],[0.7,2.3,1.6,4.5],[2.1,4,4.1,9.4]);
    Memo1.Lines.add('a:= ' + FloatToStr(a));
    Memo1.Lines.add('b:= ' + FloatToStr(b));
    Memo1.Lines.add('b:= ' + FloatToStr(c));
    Memo1.Lines.add('r:= ' + FloatToStr(r));
end;

{ Same but now for three independent variables.
  The equation: t = a + b*x + c*y + d*z.           }
procedure TForm1.Threeindepvariables1Click(Sender: TObject);
var a, b, c, d, r: extended;
begin
    MultiLinearRegression2(a,b,c,d,r,[7,1,11,11,7],[25,29,56,31,52],[6,15,8,8,6],[60,52,20,47,33]);
    Memo1.Lines.add('a:= ' + FloatToStr(a));
    Memo1.Lines.add('b:= ' + FloatToStr(b));
    Memo1.Lines.add('c:= ' + FloatToStr(c));
    Memo1.Lines.add('d:= ' + FloatToStr(d));
    Memo1.Lines.add('r:= ' + FloatToStr(r));
end;

{ Given a set of paired observations from two normal populations X and Y with unknown means 1 and 2,
  the test statistic t can be used to test the null hypothesis: 1 = 2.              }
procedure TForm1.Pairedt1Click(Sender: TObject);
var t: extended;
begin
    t:= PairedtStatistic([14,17.5,17,17.5,15.4],[17,20.7,21.6,20.9,17.2]);
    Memo1.Lines.add('t:= ' + FloatToStr(t));
end;

{ Find the value of the chi-square statistic for the goodness of fit for the following
  set of data ...                                                                       }
procedure TForm1.chi1Click(Sender: TObject);
var chi: extended;
begin
    chi:= ChiSquareStatistic([8,50,47,56,5,14],[9.6,46.75,51.85,54.4,8.25,9.15]);
    Memo1.Lines.add('chi:= ' + FloatToStr(chi));
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
     Close;
end;


end.
